#include <stdio.h>
#include <math.h>
#include <string.h>
#include "format.h"
#include <stdlib.h>


char *lire_ligne(FILE *f, char *ligne)     
{
  do
    {
      if ( fgets( ligne, MAXLIGNE, f ) == 0 ) return(0) ;
    }
  while( ligne[0]=='#' ) ;
  return(ligne) ;
}


int lire_image(char *nom, struct image  *im)
{
 FILE *f;
 char ligne[MAXLIGNE];
 int i,j; 

  f = fopen(nom,"r");
  if ( f==NULL)  return(1);
  lire_ligne(f,ligne);
  if ( (ligne[0] == 'P') && (ligne[1] == '5'))  
  {
    lire_ligne(f,ligne);
    sscanf(ligne,"%d%d",&(im->nb_col),&(im->nb_lig)); 
    im->type = 1;
    lire_ligne(f,ligne);
    ALLOUER(im->matrice.pgm,im->nb_lig);
    for (i=0 ; i<im->nb_lig ; i++)
    {
      ALLOUER(im->matrice.pgm[i],im->nb_col);
      for (j=0 ; j<im->nb_col ; j++)
          im->matrice.pgm[i][j] = (char)fgetc(f);
    }
  }
  if ( (ligne[0] == 'P') && (ligne[1] == '6'))  
  {
    lire_ligne(f,ligne);
    sscanf(ligne,"%d%d",&(im->nb_col),&(im->nb_lig)); 
    im->type = 2;
    lire_ligne(f,ligne);
    ALLOUER(im->matrice.ppm,im->nb_lig);
    for (i=0 ; i<im->nb_lig ; i++)
    {
      ALLOUER(im->matrice.ppm[i],im->nb_col);
      for (j=0 ; j<im->nb_col ; j++)
      {
        ALLOUER(im->matrice.ppm[i][j],3);
        im->matrice.ppm[i][j][0] = (char)fgetc(f);
        im->matrice.ppm[i][j][1] = (char)fgetc(f);
        im->matrice.ppm[i][j][2] = (char)fgetc(f);
      }
    }
  }
 return 0;
} 


void ecrire_image(char *nom, struct image  *im)
{
 FILE *f;
 int i,j; 

  f = fopen(nom,"w");
  if (im->type == 1)
    {
      fprintf(f,"P5\n%d %d\n255\n",im->nb_col,im->nb_lig);
      for (i=0 ; i<im->nb_lig ; i++)
	  for (j=0 ; j<im->nb_col ; j++)
	      fputc(im->matrice.pgm[i][j],f); 	
    }
  if (im->type == 2)
    {
      fprintf(f,"P6\n%d %d\n255\n",im->nb_col,im->nb_lig);
      for (i=0 ; i<im->nb_lig ; i++)
	for (j=0 ; j<im->nb_col ; j++)
	  {
	    fputc(im->matrice.ppm[i][j][0],f);
	    fputc(im->matrice.ppm[i][j][1],f);
	    fputc(im->matrice.ppm[i][j][2],f);
	  }
    }
  fclose(f); 
}


